#!/bin/csh
set thisdir = `pwd`
set dirname = "_output3d20"

if ( -d $dirname ) then
echo $dirname " does exist"
else
mkdir $dirname
endif

set thisdir = `pwd`
set runstring = "nice +7 ./converge3d.Linux.g++.g77.ex $* | tee $*.out"
echo $runstring
nice +7 ./converge3d.Linux.g++.g77.ex $* | tee $*.out
set s=$status ; if ( $s != 0 ) exit $s
cat $* $*.out > $*.total.out
set s=$status ; if ( $s != 0 ) exit $s
source ./solnerr.sh
\mv *Error* $*.total.out $*.out solnerr.sh $dirname 
set s=$status ; if ( $s != 0 ) exit $s
mail dtgraves@lbl.gov < $dirname/$*.total.out
set s=$status ; if ( $s != 0 ) exit $s
exit
