{
  size1         = $1;
  residmaxnorm1 = $5;
  residl1norm1  = $6;
  residl2norm1  = $7;
  errormaxnorm1 = $10;
  errorl1norm1  = $11;
  errorl2norm1  = $12;

  if (NR > 1) {
    if (residmaxnorm1 == 0) {
      residmaxnormrate = "  n/a ";
    } else {
      residmaxnormrate = sprintf("%6.3f",-log(residmaxnorm2/residmaxnorm1)/log(size2/size1));
    }
    if (residl1norm1 == 0) {
      residl1normrate = "  n/a ";
    } else {
      residl1normrate = sprintf("%6.3f",-log(residl1norm2/residl1norm1)/log(size2/size1));
    }
    if (residl2norm1 == 0) {
      residl2normrate = "  n/a ";
    } else {
      residl2normrate = sprintf("%6.3f",-log(residl2norm2/residl2norm1)/log(size2/size1));
    }

    if (errormaxnorm1 == 0) {
      errormaxnormrate = "  n/a ";
    } else {
      errormaxnormrate = sprintf("%6.3f",-log(errormaxnorm2/errormaxnorm1)/log(size2/size1));
    }
    if (errorl1norm1 == 0) {
      errorl1normrate = "  n/a ";
    } else {
      errorl1normrate = sprintf("%6.3f",-log(errorl1norm2/errorl1norm1)/log(size2/size1));
    }
    if (errorl2norm1 == 0) {
      errorl2normrate = "  n/a ";
    } else {
      errorl2normrate = sprintf("%6.3f",-log(errorl2norm2/errorl2norm1)/log(size2/size1));
    }

    printf("%4d    %s     %s     %s       %s     %s     %s\n",size1,residmaxnormrate,residl1normrate,residl2normrate,errormaxnormrate,errorl1normrate,errorl2normrate);
  } else {
    printf("                  Residual                        Solution Error\n");
    printf("       Max norm    L1 norm    L2 norm     Max norm    L1 norm    L2 norm\n");
    printf("       --------   --------   --------     --------   --------   --------\n");
    printf("%4d      n/a        n/a        n/a          n/a        n/a        n/a   \n",size1);
  }

  size2       = size1;

  residmaxnorm2 = residmaxnorm1;
  residl1norm2  = residl1norm1;
  residl2norm2  = residl2norm1;

  errormaxnorm2 = errormaxnorm1;
  errorl1norm2  = errorl1norm1;
  errorl2norm2  = errorl2norm1;
}
