{
  size1       = $1;
  maxnormall1 = $2;
  maxnormeb1  = $3;
  maxnormint1 = $4;
  l1normall1  = $5;
  l1normeb1   = $6;
  l1normint1  = $7;
  l2normall1  = $8;
  l2normeb1   = $9;
  l2normint1  = $10;

  if (NR == 1) {
    printf("                  All cells                        EB & Interior                        Interior\n");
    printf("       Max norm    L1 norm    L2 norm     Max norm    L1 norm    L2 norm     Max norm    L1 norm    L2 norm\n");
    printf("       --------   --------   --------     --------   --------   --------     --------   --------   --------\n");
  }

  maxnormallstr = sprintf("%8.2e",maxnormall1);
  maxnormebstr  = sprintf("%8.2e",maxnormeb1);
  maxnormintstr = sprintf("%8.2e",maxnormint1);

  l1normallstr = sprintf("%8.2e",l1normall1);
  l1normebstr  = sprintf("%8.2e",l1normeb1);
  l1normintstr = sprintf("%8.2e",l1normint1);

  l2normallstr = sprintf("%8.2e",l2normall1);
  l2normebstr  = sprintf("%8.2e",l2normeb1);
  l2normintstr = sprintf("%8.2e",l2normint1);

  printf("%4d   %s   %s   %s     %s   %s   %s     %s   %s   %s\n",size1,maxnormallstr,l1normallstr,l2normallstr,maxnormebstr,l1normebstr,l2normebstr,maxnormintstr,l1normintstr,l2normintstr);
}
