BEGIN {
  count = 0;
  section = 1;
}
/^<LI>/ {
  line[count] = $0;
  count++;
  next;
}
{
  if (count > 0) {
    for (i = 0; i < count; i++) {
      printf("%2d	%s\n",section,line[i]); 
    }
    count = 0;
    section++;
  }
}
