#ifndef _BCF_F_H_
#define _BCF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure EXTRAPGHOSTBC ...
//
#define FORT_EXTRAPGHOSTBC FORTRAN_NAME( EXTRAPGHOSTBC ,extrapghostbc )
void 
FORT_EXTRAPGHOSTBC(
      CHFp_FRA(state)
      ,CHFp_BOX(bcBox)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_INT(side)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(startcomp)
      ,CHFp_CONST_INT(endcomp) );

// Prototype for Fortran procedure HOEXTRAPGHOSTBC ...
//
#define FORT_HOEXTRAPGHOSTBC FORTRAN_NAME( HOEXTRAPGHOSTBC ,hoextrapghostbc )
void 
FORT_HOEXTRAPGHOSTBC(
      CHFp_FRA(state)
      ,CHFp_BOX(bcBox)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_INT(side)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(startcomp)
      ,CHFp_CONST_INT(endcomp) );

// Prototype for Fortran procedure REFLECTGHOSTBC ...
//
#define FORT_REFLECTGHOSTBC FORTRAN_NAME( REFLECTGHOSTBC ,reflectghostbc )
void 
FORT_REFLECTGHOSTBC(
      CHFp_FRA(state)
      ,CHFp_BOX(bcBox)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_INT(side)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(startcomp)
      ,CHFp_CONST_INT(endcomp)
      ,CHFp_CONST_REAL(scale) );

}

#endif
