      subroutine SETEXPLOSION(
     & augamma
     & ,aums
     & ,aucenter
     & ,ausize
     & ,auvelocity
     & ,auartvisc
     & )
      implicit none
      REAL*8 augamma
      REAL*8 aums
      REAL*8 aucenter(0:2)
      REAL*8 ausize
      REAL*8 auvelocity(0:2)
      REAL*8 auartvisc









        REAL*8 ms
        REAL*8 centerx,centery,centerz
        REAL*8 size
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        common /explosioncm/
     & ms,
     & centerx,centery,centerz,
     & size,
     & velx,vely,velz,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        REAL*8 r0,p0,p,ww,umag
        gamma = augamma
        ms = aums
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)
        size = ausize
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)
        artvisc = auartvisc
        p0 = (1.0d0)
        r0 = gamma
        ww = ms*r0
        p = ((ms**2 - (1.0d0))*((2.0d0)*gamma)/(gamma + (1.0d0)) + (1.0d
     &0))*p0
        umag = (p - p0)/ww
        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*(0.500d0)*umag*umag
        return
        end
      subroutine EXPLOSIONINIT(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,dx
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      REAL*8 dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 ke,r0,p0,p,uu,vv,ww,umag,r
        integer i,j,k
        REAL*8 x,y,z
        REAL*8 xcenter,ycenter,zcenter
        REAL*8 rad0sqr,radsqr









        REAL*8 ms
        REAL*8 centerx,centery,centerz
        REAL*8 size
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        common /explosioncm/
     & ms,
     & centerx,centery,centerz,
     & size,
     & velx,vely,velz,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        xcenter = centerx
        ycenter = centery
        zcenter = centerz
        rad0sqr = size*size
        p0 = (1.0d0)
        r0 = gamma
        ww = ms*r0
        p = ((ms**2 - (1.0d0))*((2.0d0)*gamma)/(gamma + (1.0d0)) + (1.0d
     &0))*p0
        r = (1.0d0)/((1.0d0)/r0 - (p - p0)/ww**2)
        umag = (p - p0)/ww
        uu = velx
        vv = vely
        ww = velz
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          x = (i + (0.500d0))*dx - xcenter
          y = (j + (0.500d0))*dx - ycenter
          z = (k + (0.500d0))*dx - zcenter
          radsqr = x*x + y*y + z*z
          if (radsqr .ge. rad0sqr) then
            U(i,j,k,0) = r0
            U(i,j,k,1) = uu*r0
            U(i,j,k,2) = vv*r0
            U(i,j,k,3) = ww*r0
            U(i,j,k,4) = p0/(gamma - (1.0d0)) + r0*ke
          else
            U(i,j,k,0) = r
            U(i,j,k,1) = uu*r
            U(i,j,k,2) = vv*r
            U(i,j,k,3) = ww*r
            U(i,j,k,4) = p/(gamma - (1.0d0)) + r*ke
          endif
      enddo
      enddo
      enddo
        return
        end
