      subroutine SETRAMP(
     & augamma
     & ,aualpha
     & ,aums
     & ,auxcorner
     & ,auartvisc
     & )
      implicit none
      REAL*8 augamma
      REAL*8 aualpha
      REAL*8 aums
      REAL*8 auxcorner
      REAL*8 auartvisc
        REAL*8 pi











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        REAL*8 ke,r0,p0,p,uu,vv,ww,umag,r
        REAL*8 sinalpha,cosalpha,tanalpha
        gamma = augamma
        alpha = aualpha 
        pi = atan((1.0d0))*(4.0d0)
        alpha = alpha*pi/((9.0d0)*(20.0d0))
        ms = aums
        xcorner = auxcorner
        artvisc = auartvisc
        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)
        p0 = (1.0d0)
        r0 = gamma
        ww = ms*r0
        p = ((ms**2 - (1.0d0))*((2.0d0)*gamma)/(gamma + (1.0d0)) + (1.0d
     &0))*p0
        r = (1.0d0)/((1.0d0)/r0 - (p - p0)/ww**2)
        umag = (p - p0)/ww
        uu = umag*cosalpha
        vv = -umag*sinalpha
        ww = (0.0d0)
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*(0.500d0)*umag*umag
        return
        end
      subroutine RAMPINIT(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,dx
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      REAL*8 dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 ke,r0,p0,p,uu,vv,ww,umag,r
        REAL*8 sinalpha,cosalpha,tanalpha
        integer i,j,k
        REAL*8 x,y,z
        REAL*8 xofy











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)
        p0 = (1.0d0)
        r0 = gamma
        ww = ms*r0
        p = ((ms**2 - (1.0d0))*((2.0d0)*gamma)/(gamma + (1.0d0)) + (1.0d
     &0))*p0
        r = (1.0d0)/((1.0d0)/r0 - (p - p0)/ww**2)
        umag = (p - p0)/ww
        uu = umag*cosalpha
        vv =-umag*sinalpha
        ww = (0.0d0)
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          x = (i + (0.500d0))*dx
          y = (j + (0.500d0))*dx
          z = (k + (0.500d0))*dx
          xofy = xcorner + y*tanalpha
          if (x .ge. xofy) then
            U(i,j,k,0) = r0
            U(i,j,k,1) = (0.0d0)
            U(i,j,k,2) = (0.0d0)
            U(i,j,k,3) = (0.0d0)
            U(i,j,k,4) = p0/(gamma - (1.0d0))
          else
            U(i,j,k,0) = r
            U(i,j,k,1) = uu*r
            U(i,j,k,2) = vv*r
            U(i,j,k,3) = (0.0d0)
            U(i,j,k,4) = p/(gamma - (1.0d0)) + r*ke
          endif
      enddo
      enddo
      enddo
        return
        end
      subroutine RAMPBC(
     & F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,time
     & ,lohisign
     & ,dx
     & ,dir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      REAL*8 time
      integer lohisign
      REAL*8 dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 ke,r0,p0,umag,p,r
        REAL*8 x,y,z
        REAL*8 xofy,rg,pg,ws
        REAL*8 ug,vg,wg
        REAL*8 uu,vv,ww
        integer i,j,k
        REAL*8 cosalpha,sinalpha,tanalpha











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)
        r0 = gamma
        p0 = (1.0d0)
        ws = ms*r0
        p = ((ms**2-(1.0d0))*(2.0d0)*gamma/(gamma + (1.0d0)) + (1.0d0))*
     &p0
        umag = (p - p0)/ws
        r = (1.0d0)/((1.0d0)/r0 - (p - p0)/ws**2)
        uu = umag*cosalpha
        vv =-umag*sinalpha
        ww = (0.0d0)
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
        if (dir .eq. 1) then
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            x = (i + (0.500d0))*dx
            y = j *dx
            z = (k + (0.500d0))*dx
            if (lohisign .eq. 1) then
              xofy = xcorner + y*tanalpha + ms*time/cosalpha
              if (x .ge. xofy) then
                F(i,j,k,0) = (0.0d0)
                F(i,j,k,1) = (0.0d0)
                F(i,j,k,2) = p0
                F(i,j,k,3) = (0.0d0)
                F(i,j,k,4) = (0.0d0)
              else
                F(i,j,k,0) = vv*r
                F(i,j,k,1) = uu*vv*r
                F(i,j,k,2) = vv*vv*r + p
                F(i,j,k,3) = (0.0d0)
                F(i,j,k,4) = vv*(p/(gamma - (1.0d0)) + r*ke + p)
              endif
            else
              if (x .le. xcorner) then
                rg = W(i,j,k,0)
                ug = W(i,j,k,1)
                vg = W(i,j,k,2)
                wg = W(i,j,k,3)
                pg = W(i,j,k,4)
                F(i,j,k,0) = vg*rg
                F(i,j,k,1) = vg*ug*rg
                F(i,j,k,2) = vg*vg*rg + pg
                F(i,j,k,3) = vg*wg*rg
                ke = (0.500d0)*(ug*ug + vg*vg + wg*wg)
                F(i,j,k,4) = vg*(pg/(gamma - (1.0d0)) +
     & ke*rg + pg)
              endif
            endif
      enddo
      enddo
      enddo
        endif
        if (dir .eq. 0) then
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            if (lohisign .eq. -1) then
              F(i,j,k,0) = r*uu
              F(i,j,k,1) = r*uu*uu + p
              F(i,j,k,2) = r*uu*vv
              F(i,j,k,3) = r*uu*ww
              F(i,j,k,4) = uu*(p/(gamma - (1.0d0)) + ke*r + p)
            else
              F(i,j,k,0) = (0.0d0)
              F(i,j,k,1) = p0
              F(i,j,k,2) = (0.0d0)
              F(i,j,k,3) = (0.0d0)
              F(i,j,k,4) = (0.0d0)
            endif
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine RAMPSOLIDBC(
     & F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,Wextrap
     & ,iWextraplo0,iWextraplo1,iWextraplo2
     & ,iWextraphi0,iWextraphi1,iWextraphi2
     & ,nWextrapcomp
     & ,lohisign
     & ,dx
     & ,dir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      integer nWextrapcomp
      integer iWextraplo0,iWextraplo1,iWextraplo2
      integer iWextraphi0,iWextraphi1,iWextraphi2
      REAL*8 Wextrap(
     & iWextraplo0:iWextraphi0,
     & iWextraplo1:iWextraphi1,
     & iWextraplo2:iWextraphi2,
     & 0:nWextrapcomp-1)
      integer lohisign
      REAL*8 dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 p,rho,unorm,speed
        integer i,j,k











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          p = Wextrap(i,j,k,4)
          rho = max(Wextrap(i,j,k,0),smallr)
          unorm = Wextrap(i,j,k,1 + dir)
          speed = sqrt(gamma*p/rho)
          F(i,j,k,0) = (0.0d0)
          F(i,j,k,1) = (0.0d0)
          F(i,j,k,2) = (0.0d0)
          F(i,j,k,3) = (0.0d0)
          F(i,j,k,1 + dir) = p + lohisign * rho * unorm * speed
          F(i,j,k,4) = (0.0d0)
      enddo
      enddo
      enddo
        return
        end
      subroutine RAMPSLOPEBCS(
     & dW
     & ,idWlo0,idWlo1,idWlo2
     & ,idWhi0,idWhi1,idWhi2
     & ,ndWcomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,dx
     & ,dir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL*8 dW(
     & idWlo0:idWhi0,
     & idWlo1:idWhi1,
     & idWlo2:idWhi2,
     & 0:ndWcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      REAL*8 dx
      integer dir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
        integer i,j,k,ioff,joff,koff
        integer inorm,itan1,itan2,spacedim
        REAL*8 dvhi,dvlo,dvmin,x











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc
        spacedim = 3
        ioff = CHF_ID(0,dir)
        joff = CHF_ID(1,dir)
        koff = CHF_ID(2,dir)
        inorm = 1 + dir
        itan1 = 1 + mod(dir + 1,spacedim)
        itan2 = 1 + mod(dir + 2,spacedim)
        if ((dir .eq. 1) .and. (hasLo .eq. 1)) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            x = (i + (0.500d0))*dx
            if (x .ge. xcorner) then
              dW(i,j,k,0) = (0.0d0)
              dW(i,j,k,4) = (0.0d0)
              dvhi = W(i + ioff,j + joff,k + koff,inorm) -
     & W(i ,j ,k ,inorm)
              dvlo = W(i ,j ,k ,inorm)*(2.0d0)
              dvmin = min((2.0d0)*abs(dvhi),abs(dvlo))*sign((1.0d0),dvlo
     &)
              if (dvlo*dvhi .lt. (0.0d0)) dvmin = (0.0d0)
              dW(i,j,k,inorm) = dvmin
              dW(i,j,k,itan1) = (0.0d0)
              dW(i,j,k,itan2) = (0.0d0)
            endif
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine RAMPARTVISC(
     & F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,divu
     & ,idivulo0,idivulo1,idivulo2
     & ,idivuhi0,idivuhi1,idivuhi2
     & ,lohisign
     & ,dx
     & ,dir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer idivulo0,idivulo1,idivulo2
      integer idivuhi0,idivuhi1,idivuhi2
      REAL*8 divu(
     & idivulo0:idivuhi0,
     & idivulo1:idivuhi1,
     & idivulo2:idivuhi2)
      integer lohisign
      REAL*8 dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        REAL*8 x
        REAL*8 fc,dv,s











        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        if (dir .eq. 1) then
          if (lohisign .eq. -1) then
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
              x = (i + (0.500d0))*dx;
                if (x .gt. xcorner) then
                  fc = F (i, j, k,1 + dir)
                  dv = divu(i, j, k)
                  s = U (i, j, k,1 + dir)
                  F(i,j,k,1 + dir) = fc - lohisign*artvisc*min(dv,(0.0d0
     &))*(2*s)
                endif
      enddo
      enddo
      enddo
          endif
        endif
        return
        end
