#ifndef _BENCHMARKF_F_H_
#define _BENCHMARKF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETBENCHMARK ...
//
#define FORT_SETBENCHMARK FORTRAN_NAME( SETBENCHMARK ,setbenchmark )
void 
FORT_SETBENCHMARK(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(auenergy)
      ,CHFp_CONST_REAL(aurho0)
      ,CHFp_CONST_REAL(aup0)
      ,CHFp_CONST_REALVECT(aucenter)
      ,CHFp_CONST_REAL(ausize)
      ,CHFp_CONST_REALVECT(auvelocity)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure BENCHMARKINIT ...
//
#define FORT_BENCHMARKINIT FORTRAN_NAME( BENCHMARKINIT ,benchmarkinit )
void 
FORT_BENCHMARKINIT(
      CHFp_FRA(U)
      ,CHFp_REAL(sumScaledEnergy)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure BENCHMARKINITCORRECT ...
//
#define FORT_BENCHMARKINITCORRECT FORTRAN_NAME( BENCHMARKINITCORRECT ,benchmarkinitcorrect )
void 
FORT_BENCHMARKINITCORRECT(
      CHFp_FRA(U)
      ,CHFp_REAL(scaling)
      ,CHFp_REAL(sumScaledEnergy)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}

#endif
