#ifndef _GAUSSIANF_F_H_
#define _GAUSSIANF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETGAUSSIAN ...
//
#define FORT_SETGAUSSIAN FORTRAN_NAME( SETGAUSSIAN ,setgaussian )
void 
FORT_SETGAUSSIAN(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(auambientDensity)
      ,CHFp_CONST_REAL(audeltaDensity)
      ,CHFp_CONST_INT(aupressure)
      ,CHFp_CONST_REALVECT(aucenter)
      ,CHFp_CONST_REAL(ausize)
      ,CHFp_CONST_REALVECT(auvelocity)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure GAUSSIANINIT ...
//
#define FORT_GAUSSIANINIT FORTRAN_NAME( GAUSSIANINIT ,gaussianinit )
void 
FORT_GAUSSIANINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}

#endif
