#ifndef _WAVEF_F_H_
#define _WAVEF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETWAVE ...
//
#define FORT_SETWAVE FORTRAN_NAME( SETWAVE ,setwave )
void 
FORT_SETWAVE(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(auambientDensity)
      ,CHFp_CONST_REAL(audeltaDensity)
      ,CHFp_CONST_INT(aupressure)
      ,CHFp_CONST_INTVECT(auwaveNumber)
      ,CHFp_CONST_REALVECT(aucenter)
      ,CHFp_CONST_REALVECT(auvelocity)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure WAVEINIT ...
//
#define FORT_WAVEINIT FORTRAN_NAME( WAVEINIT ,waveinit )
void 
FORT_WAVEINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}

#endif
