#!/bin/csh
#note the backquote
set array = ( 2 4 6 8 10 )
set arraysize = $#array
echo "arraysize = " $arraysize

foreach nfine ($array)

echo "nfine = " $nfine
set dirname =  _output3d$nfine
echo "dirname = " $dirname

if ( -d $dirname ) then
echo $dirname " does exist"
else
mkdir $dirname
endif

set runstring = "nice +7 ./converge3d.Linux.g++.g77.ex $* max_step=$nfine  | tee $*.out "
echo $runstring
nice +7 ./converge3d.Linux.g++.g77.ex $* max_step=$nfine  | tee $*.out 
set runstring = "cat $* $*.out > $*.total.out"
echo $runstring
cat $* $*.out > $*.total.out
set runstring = "source ./solnerr.sh"
echo $runstring
source ./solnerr.sh
set runstring = "\mv *Error* $*.out $*.total.out solnerr.sh $dirname "
echo $runstring
\mv *Error* $*.out $*.total.out solnerr.sh $dirname 

end

mail dtgraves@lbl.gov < multirun.sh

exit
