{
  size1       = $1;
  maxnormall1 = $2;
  maxnormeb1  = $3;
  maxnormint1 = $4;
  l1normall1  = $5;
  l1normeb1   = $6;
  l1normint1  = $7;
  l2normall1  = $8;
  l2normeb1   = $9;
  l2normint1  = $10;

  if (NR > 1) {
    if (maxnormall1 == 0) {
      maxnormallrate = "  n/a ";
    } else {
      maxnormallrate = sprintf("%6.3f",-log(maxnormall2/maxnormall1)/log(size2/size1));
    }
    if (maxnormeb1 == 0) {
      maxnormebrate = "  n/a ";
    } else {
      maxnormebrate = sprintf("%6.3f",-log(maxnormeb2/maxnormeb1)/log(size2/size1));
    }
    if (maxnormint1 == 0) {
      maxnormintrate = "  n/a ";
    } else {
      maxnormintrate = sprintf("%6.3f",-log(maxnormint2/maxnormint1)/log(size2/size1));
    }

    if (l1normall1 == 0) {
      l1normallrate = "  n/a ";
    } else {
      l1normallrate = sprintf("%6.3f",-log(l1normall2/l1normall1)/log(size2/size1));
    }
    if (l1normeb1 == 0) {
      l1normebrate = "  n/a ";
    } else {
      l1normebrate = sprintf("%6.3f",-log(l1normeb2/l1normeb1)/log(size2/size1));
    }
    if (l1normint1 == 0) {
      l1normintrate = "  n/a ";
    } else {
      l1normintrate = sprintf("%6.3f",-log(l1normint2/l1normint1)/log(size2/size1));
    }

    if (l2normall1 == 0) {
      l2normallrate = "  n/a ";
    } else {
      l2normallrate = sprintf("%6.3f",-log(l2normall2/l2normall1)/log(size2/size1));
    }
    if (l2normeb1 == 0) {
      l2normebrate = "  n/a ";
    } else {
      l2normebrate = sprintf("%6.3f",-log(l2normeb2/l2normeb1)/log(size2/size1));
    }
    if (l2normint1 == 0) {
      l2normintrate = "  n/a ";
    } else {
      l2normintrate = sprintf("%6.3f",-log(l2normint2/l2normint1)/log(size2/size1));
    }

    printf("%4d    %s     %s     %s       %s     %s     %s       %s     %s     %s\n",size1,maxnormallrate,l1normallrate,l2normallrate,maxnormebrate,l1normebrate,l2normebrate,maxnormintrate,l1normintrate,l2normintrate);
  } else {
    printf("                  All cells                        EB & Interior                        Interior\n");
    printf("       Max norm    L1 norm    L2 norm     Max norm    L1 norm    L2 norm     Max norm    L1 norm    L2 norm\n");
    printf("       --------   --------   --------     --------   --------   --------     --------   --------   --------\n");
    printf("%4d      n/a        n/a        n/a          n/a        n/a        n/a          n/a        n/a        n/a\n",size1);
  }

  size2       = size1;
  maxnormall2 = maxnormall1;
  maxnormeb2  = maxnormeb1;
  maxnormint2 = maxnormint1;
  l1normall2  = l1normall1;
  l1normeb2   = l1normeb1;
  l1normint2  = l1normint1;
  l2normall2  = l2normall1;
  l2normeb2   = l2normeb1;
  l2normint2  = l2normint1;
}
