C -*- Mode: Fortran; -*-
c-----------------------------------------------------------------------
c     Ravi Samtaney
c     Copyright 2002
c     Princeton Plasma Physics Laboratory
c     All Rights Reserved
c-----------------------------------------------------------------------
c     $Log: setalphas.F,v $
c     Revision 1.1  2002/06/13 22:16:18  samtaney
c     Original unsplit 8-wave Ideal MHD source (includes B filter).
c
c-----------------------------------------------------------------------
      subroutine SetAlphas(utilde,alpha,durl,evl,evr,ilo,ihi,direction)
c
      implicit none
c
c     Incoming arguments
      integer ilo,ihi,direction
      real*8 utilde(ilo:ihi,8)
      real*8 alpha(ilo:ihi,8)
      real*8 durl(ilo:ihi,8)
      real*8 evl(ilo:ihi,8,8)
      real*8 evr(ilo:ihi,8,8)
c
c     Local variables
      integer i,k,l

c     
      do i=ilo,ihi,1
         do l=1,8,1
            alpha(i,l)=0.D0
            do k=1,8,1
               alpha(i,l)=alpha(i,l)+evl(i,l,k)*durl(i,k)
            enddo
         enddo
      enddo
c
      return
      end 




