      subroutine MINFLAT(
     & flattening
     & ,iflatteninglo0,iflatteninglo1,iflatteninglo2
     & ,iflatteninghi0,iflatteninghi1,iflatteninghi2
     & ,zetaDir
     & ,izetaDirlo0,izetaDirlo1,izetaDirlo2
     & ,izetaDirhi0,izetaDirhi1,izetaDirhi2
     & ,nzetaDircomp
     & ,du
     & ,idulo0,idulo1,idulo2
     & ,iduhi0,iduhi1,iduhi2
     & ,nducomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer iflatteninglo0,iflatteninglo1,iflatteninglo2
      integer iflatteninghi0,iflatteninghi1,iflatteninghi2
      REAL*8 flattening(
     & iflatteninglo0:iflatteninghi0,
     & iflatteninglo1:iflatteninghi1,
     & iflatteninglo2:iflatteninghi2)
      integer nzetaDircomp
      integer izetaDirlo0,izetaDirlo1,izetaDirlo2
      integer izetaDirhi0,izetaDirhi1,izetaDirhi2
      REAL*8 zetaDir(
     & izetaDirlo0:izetaDirhi0,
     & izetaDirlo1:izetaDirhi1,
     & izetaDirlo2:izetaDirhi2,
     & 0:nzetaDircomp-1)
      integer nducomp
      integer idulo0,idulo1,idulo2
      integer iduhi0,iduhi1,iduhi2
      REAL*8 du(
     & idulo0:iduhi0,
     & idulo1:iduhi1,
     & idulo2:iduhi2,
     & 0:nducomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        integer iv
        REAL*8 sumdu,minflattot,minZetaDir
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          sumdu = (0.0d0)
          do iv = 0,nducomp - 1
            sumdu = sumdu + du(i,j,k,iv)
          enddo
          if (sumdu .lt. (0.0d0)) then
            minflattot = zetaDir(i,j,k,0)
            do iv = 1,nducomp - 1
              minZetaDir = zetaDir(i,j,k,iv)
              minflattot = min(minflattot,minZetaDir)
            enddo
            flattening(i,j,k) = minflattot
          else
            flattening(i,j,k) = (1.0d0)
          endif
      enddo
      enddo
      enddo
        return
        end
      subroutine GETDPTWO(
     & delta2p
     & ,idelta2plo0,idelta2plo1,idelta2plo2
     & ,idelta2phi0,idelta2phi1,idelta2phi2
     & ,delta1p
     & ,idelta1plo0,idelta1plo1,idelta1plo2
     & ,idelta1phi0,idelta1phi1,idelta1phi2
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer idelta2plo0,idelta2plo1,idelta2plo2
      integer idelta2phi0,idelta2phi1,idelta2phi2
      REAL*8 delta2p(
     & idelta2plo0:idelta2phi0,
     & idelta2plo1:idelta2phi1,
     & idelta2plo2:idelta2phi2)
      integer idelta1plo0,idelta1plo1,idelta1plo2
      integer idelta1phi0,idelta1phi1,idelta1phi2
      REAL*8 delta1p(
     & idelta1plo0:idelta1phi0,
     & idelta1plo1:idelta1phi1,
     & idelta1plo2:idelta1phi2)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k
        integer ioff,joff,koff
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          delta2p(i,j,k) = delta1p(i+ioff,j+joff,k+koff)
     & + delta1p(i-ioff,j-joff,k-koff)
      enddo
      enddo
      enddo
        if (hasLo .eq. 1) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            delta2p(i,j,k) = delta1p(i+ioff,j+joff,k+koff)
     & + delta1p(i ,j ,k )
      enddo
      enddo
      enddo
        endif
        if (hasHi .eq. 1) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
            delta2p(i,j,k) = delta1p(i ,j ,k )
     & + delta1p(i-ioff,j-joff,k-koff)
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine GETFLAT(
     & zetaTwiddle
     & ,izetaTwiddlelo0,izetaTwiddlelo1,izetaTwiddlelo2
     & ,izetaTwiddlehi0,izetaTwiddlehi1,izetaTwiddlehi2
     & ,delta1p
     & ,idelta1plo0,idelta1plo1,idelta1plo2
     & ,idelta1phi0,idelta1phi1,idelta1phi2
     & ,delta2p
     & ,idelta2plo0,idelta2plo1,idelta2plo2
     & ,idelta2phi0,idelta2phi1,idelta2phi2
     & ,bulkMin
     & ,ibulkMinlo0,ibulkMinlo1,ibulkMinlo2
     & ,ibulkMinhi0,ibulkMinhi1,ibulkMinhi2
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer izetaTwiddlelo0,izetaTwiddlelo1,izetaTwiddlelo2
      integer izetaTwiddlehi0,izetaTwiddlehi1,izetaTwiddlehi2
      REAL*8 zetaTwiddle(
     & izetaTwiddlelo0:izetaTwiddlehi0,
     & izetaTwiddlelo1:izetaTwiddlehi1,
     & izetaTwiddlelo2:izetaTwiddlehi2)
      integer idelta1plo0,idelta1plo1,idelta1plo2
      integer idelta1phi0,idelta1phi1,idelta1phi2
      REAL*8 delta1p(
     & idelta1plo0:idelta1phi0,
     & idelta1plo1:idelta1phi1,
     & idelta1plo2:idelta1phi2)
      integer idelta2plo0,idelta2plo1,idelta2plo2
      integer idelta2phi0,idelta2phi1,idelta2phi2
      REAL*8 delta2p(
     & idelta2plo0:idelta2phi0,
     & idelta2plo1:idelta2phi1,
     & idelta2plo2:idelta2phi2)
      integer ibulkMinlo0,ibulkMinlo1,ibulkMinlo2
      integer ibulkMinhi0,ibulkMinhi1,ibulkMinhi2
      REAL*8 bulkMin(
     & ibulkMinlo0:ibulkMinhi0,
     & ibulkMinlo1:ibulkMinhi1,
     & ibulkMinlo2:ibulkMinhi2)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        REAL*8 d,r0,r1,ratio,strength



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        data d /0.33d0/
        data r0 /0.75d0/
        data r1 /0.85d0/
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          strength = abs(delta1p(i,j,k)/bulkMin(i,j,k))
          if (strength .ge. d) then
            ratio = abs(delta1p(i,j,k)
     & / max(abs(delta2p(i,j,k)),smallp))
            if (ratio .le. r0) then
              zetaTwiddle(i,j,k) = (1.0d0)
            else if (ratio .ge. r1) then
              zetaTwiddle(i,j,k) = (0.0d0)
            else
              zetaTwiddle(i,j,k) = (1.0d0) - (ratio - r0)/(r1 - r0)
            endif
          else
            zetaTwiddle(i,j,k) = (1.0d0)
          endif
      enddo
      enddo
      enddo
        return
        end
      subroutine GETGRAD(
     & du
     & ,idulo0,idulo1,idulo2
     & ,iduhi0,iduhi1,iduhi2
     & ,u
     & ,iulo0,iulo1,iulo2
     & ,iuhi0,iuhi1,iuhi2
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer idulo0,idulo1,idulo2
      integer iduhi0,iduhi1,iduhi2
      REAL*8 du(
     & idulo0:iduhi0,
     & idulo1:iduhi1,
     & idulo2:iduhi2)
      integer iulo0,iulo1,iulo2
      integer iuhi0,iuhi1,iuhi2
      REAL*8 u(
     & iulo0:iuhi0,
     & iulo1:iuhi1,
     & iulo2:iuhi2)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k
        integer ioff,joff,koff
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          du(i,j,k) = (0.500d0)*(u(i+ioff,j+joff,k+koff)
     & -u(i-ioff,j-joff,k-koff))
      enddo
      enddo
      enddo
        if (hasLo .eq. 1) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            du(i,j,k) = (u(i+ioff,j+joff,k+koff)
     & - u(i ,j ,k ))
      enddo
      enddo
      enddo
        endif
        if (hasHi .eq. 1) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
            du(i,j,k) = (u(i ,j ,k )
     & - u(i-ioff,j-joff,k-koff))
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine MAGNITUDE(
     & magdata
     & ,imagdatalo0,imagdatalo1,imagdatalo2
     & ,imagdatahi0,imagdatahi1,imagdatahi2
     & ,data
     & ,idatalo0,idatalo1,idatalo2
     & ,idatahi0,idatahi1,idatahi2
     & ,ndatacomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer imagdatalo0,imagdatalo1,imagdatalo2
      integer imagdatahi0,imagdatahi1,imagdatahi2
      REAL*8 magdata(
     & imagdatalo0:imagdatahi0,
     & imagdatalo1:imagdatahi1,
     & imagdatalo2:imagdatahi2)
      integer ndatacomp
      integer idatalo0,idatalo1,idatalo2
      integer idatahi0,idatahi1,idatahi2
      REAL*8 data(
     & idatalo0:idatahi0,
     & idatalo1:idatahi1,
     & idatalo2:idatahi2,
     & 0:ndatacomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        integer iv
        REAL*8 cur,sum
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          sum = (0.0d0)
          do iv = 0,ndatacomp-1
            cur = data(i,j,k,iv)
            sum = sum + cur*cur
          enddo
          magdata(i,j,k) = sqrt(sum)
      enddo
      enddo
      enddo
        return
        end
      subroutine MIN3PTS(
     & mindata
     & ,imindatalo0,imindatalo1,imindatalo2
     & ,imindatahi0,imindatahi1,imindatahi2
     & ,data
     & ,idatalo0,idatalo1,idatalo2
     & ,idatahi0,idatahi1,idatahi2
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer imindatalo0,imindatalo1,imindatalo2
      integer imindatahi0,imindatahi1,imindatahi2
      REAL*8 mindata(
     & imindatalo0:imindatahi0,
     & imindatalo1:imindatahi1,
     & imindatalo2:imindatahi2)
      integer idatalo0,idatalo1,idatalo2
      integer idatahi0,idatahi1,idatahi2
      REAL*8 data(
     & idatalo0:idatahi0,
     & idatalo1:idatahi1,
     & idatalo2:idatahi2)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k
        integer ioff,joff,koff
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          mindata(i,j,k) = min(data(i ,j ,k ),
     & data(i+ioff,j+joff,k+koff),
     & data(i-ioff,j-joff,k-koff))
      enddo
      enddo
      enddo
        if (hasLo .ne. 0) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            mindata(i,j,k) = min(data(i ,j ,k ),
     & data(i+ioff,j+joff,k+koff))
      enddo
      enddo
      enddo
        endif
        if (hasHi .ne. 0) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
            mindata(i,j,k) = min(data(i ,j ,k ),
     & data(i-ioff,j-joff,k-koff))
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine SECONDSLOPEDIFFS(
     & deltaWC
     & ,ideltaWClo0,ideltaWClo1,ideltaWClo2
     & ,ideltaWChi0,ideltaWChi1,ideltaWChi2
     & ,ndeltaWCcomp
     & ,deltaWL
     & ,ideltaWLlo0,ideltaWLlo1,ideltaWLlo2
     & ,ideltaWLhi0,ideltaWLhi1,ideltaWLhi2
     & ,ndeltaWLcomp
     & ,deltaWR
     & ,ideltaWRlo0,ideltaWRlo1,ideltaWRlo2
     & ,ideltaWRhi0,ideltaWRhi1,ideltaWRhi2
     & ,ndeltaWRcomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,numSlopes
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer ndeltaWCcomp
      integer ideltaWClo0,ideltaWClo1,ideltaWClo2
      integer ideltaWChi0,ideltaWChi1,ideltaWChi2
      REAL*8 deltaWC(
     & ideltaWClo0:ideltaWChi0,
     & ideltaWClo1:ideltaWChi1,
     & ideltaWClo2:ideltaWChi2,
     & 0:ndeltaWCcomp-1)
      integer ndeltaWLcomp
      integer ideltaWLlo0,ideltaWLlo1,ideltaWLlo2
      integer ideltaWLhi0,ideltaWLhi1,ideltaWLhi2
      REAL*8 deltaWL(
     & ideltaWLlo0:ideltaWLhi0,
     & ideltaWLlo1:ideltaWLhi1,
     & ideltaWLlo2:ideltaWLhi2,
     & 0:ndeltaWLcomp-1)
      integer ndeltaWRcomp
      integer ideltaWRlo0,ideltaWRlo1,ideltaWRlo2
      integer ideltaWRhi0,ideltaWRhi1,ideltaWRhi2
      REAL*8 deltaWR(
     & ideltaWRlo0:ideltaWRhi0,
     & ideltaWRlo1:ideltaWRhi1,
     & ideltaWRlo2:ideltaWRhi2,
     & 0:ndeltaWRcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      integer numSlopes
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k ,lvar
        integer ioff,joff,koff
        REAL*8 dWR,dWL
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
        do lvar = 0,numSlopes - 1
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
            dWR = W(i+ioff,j+joff,k+koff,lvar)
     & - W(i ,j ,k ,lvar)
            dWL = W(i ,j ,k ,lvar)
     & - W(i-ioff,j-joff,k-koff,lvar)
            deltaWR(i,j,k,lvar) = dWR
            deltaWL(i,j,k,lvar) = dWL
            deltaWC(i,j,k,lvar) = (0.500d0)*(dWR + dWL)
      enddo
      enddo
      enddo
          if (hasLo .ne. 0) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
              dWR = W(i+ioff,j+joff,k+koff,lvar)
     & - W(i ,j ,k ,lvar)
              deltaWC(i,j,k,lvar) = dWR
              deltaWL(i,j,k,lvar) = dWR
              deltaWR(i,j,k,lvar) = dWR
      enddo
      enddo
      enddo
          endif
          if (hasHi .ne. 0) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
              dWL = W(i ,j ,k ,lvar)
     & - W(i-ioff,j-joff,k-koff,lvar)
              deltaWC(i,j,k,lvar) = dWL
              deltaWL(i,j,k,lvar) = dWL
              deltaWR(i,j,k,lvar) = dWL
      enddo
      enddo
      enddo
          endif
        enddo
        return
        end
      subroutine FOURTHSLOPEDIFFS(
     & delta4WC
     & ,idelta4WClo0,idelta4WClo1,idelta4WClo2
     & ,idelta4WChi0,idelta4WChi1,idelta4WChi2
     & ,ndelta4WCcomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,delta2W
     & ,idelta2Wlo0,idelta2Wlo1,idelta2Wlo2
     & ,idelta2Whi0,idelta2Whi1,idelta2Whi2
     & ,ndelta2Wcomp
     & ,numSlopes
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer ndelta4WCcomp
      integer idelta4WClo0,idelta4WClo1,idelta4WClo2
      integer idelta4WChi0,idelta4WChi1,idelta4WChi2
      REAL*8 delta4WC(
     & idelta4WClo0:idelta4WChi0,
     & idelta4WClo1:idelta4WChi1,
     & idelta4WClo2:idelta4WChi2,
     & 0:ndelta4WCcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      integer ndelta2Wcomp
      integer idelta2Wlo0,idelta2Wlo1,idelta2Wlo2
      integer idelta2Whi0,idelta2Whi1,idelta2Whi2
      REAL*8 delta2W(
     & idelta2Wlo0:idelta2Whi0,
     & idelta2Wlo1:idelta2Whi1,
     & idelta2Wlo2:idelta2Whi2,
     & 0:ndelta2Wcomp-1)
      integer numSlopes
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k ,lvar
        integer ioff,joff,koff
        REAL*8 dWR,dWL
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
        do lvar = 0,numSlopes - 1
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
            dWR = W(i+ioff,j+joff,k+koff,lvar)
     & - delta2W(i+ioff,j+joff,k+koff,lvar)*(0.250d0)
            dWL = W(i-ioff,j-joff,k-koff,lvar)
     & + delta2W(i-ioff,j-joff,k-koff,lvar)*(0.250d0)
            delta4WC(i,j,k,lvar) = (2.000d0 / 3.000d0)*(dWR - dWL)
      enddo
      enddo
      enddo
          if (hasLo .ne. 0) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
              delta4WC(i,j,k,lvar) = delta2W(i,j,k,lvar)
      enddo
      enddo
      enddo
          endif
          if (hasHi .ne. 0) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
              delta4WC(i,j,k,lvar) = delta2W(i,j,k,lvar)
      enddo
      enddo
      enddo
          endif
        enddo
        return
        end
      subroutine APPLYFLAT(
     & dW
     & ,idWlo0,idWlo1,idWlo2
     & ,idWhi0,idWhi1,idWhi2
     & ,ndWcomp
     & ,flattening
     & ,iflatteninglo0,iflatteninglo1,iflatteninglo2
     & ,iflatteninghi0,iflatteninghi1,iflatteninghi2
     & ,numSlopes
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL*8 dW(
     & idWlo0:idWhi0,
     & idWlo1:idWhi1,
     & idWlo2:idWhi2,
     & 0:ndWcomp-1)
      integer iflatteninglo0,iflatteninglo1,iflatteninglo2
      integer iflatteninghi0,iflatteninghi1,iflatteninghi2
      REAL*8 flattening(
     & iflatteninglo0:iflatteninghi0,
     & iflatteninglo1:iflatteninghi1,
     & iflatteninglo2:iflatteninghi2)
      integer numSlopes
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k,lvar
        do lvar = 0,numSlopes - 1
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            dW(i,j,k,lvar) = flattening(i,j,k)
     & * dW(i,j,k,lvar)
      enddo
      enddo
      enddo
        enddo
        return
        end
      subroutine VANLEERLIMITER(
     & dW
     & ,idWlo0,idWlo1,idWlo2
     & ,idWhi0,idWhi1,idWhi2
     & ,ndWcomp
     & ,dWleft
     & ,idWleftlo0,idWleftlo1,idWleftlo2
     & ,idWlefthi0,idWlefthi1,idWlefthi2
     & ,ndWleftcomp
     & ,dWright
     & ,idWrightlo0,idWrightlo1,idWrightlo2
     & ,idWrighthi0,idWrighthi1,idWrighthi2
     & ,ndWrightcomp
     & ,idir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL*8 dW(
     & idWlo0:idWhi0,
     & idWlo1:idWhi1,
     & idWlo2:idWhi2,
     & 0:ndWcomp-1)
      integer ndWleftcomp
      integer idWleftlo0,idWleftlo1,idWleftlo2
      integer idWlefthi0,idWlefthi1,idWlefthi2
      REAL*8 dWleft(
     & idWleftlo0:idWlefthi0,
     & idWleftlo1:idWlefthi1,
     & idWleftlo2:idWlefthi2,
     & 0:ndWleftcomp-1)
      integer ndWrightcomp
      integer idWrightlo0,idWrightlo1,idWrightlo2
      integer idWrighthi0,idWrighthi1,idWrighthi2
      REAL*8 dWright(
     & idWrightlo0:idWrighthi0,
     & idWrightlo1:idWrighthi1,
     & idWrightlo2:idWrighthi2,
     & 0:ndWrightcomp-1)
      integer idir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k,iv
        REAL*8 dWl,dWr,dWc,dWlim
        do iv = 0,ndWcomp - 1
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            dWc = dW (i,j,k,iv)
            dWl = dWleft (i,j,k,iv)
            dWr = dWright(i,j,k,iv)
            dWlim = min((2.0d0)*abs(dWl),(2.0d0)*abs(dWr))
            dWlim = min(dWlim,abs(dWc))
            if (dWl*dWr .lt. (0.0d0)) then
              dWlim = (0.0d0)
            else
              dWlim = dWlim*sign((1.0d0),dWl)
            endif
            dW(i,j,k,iv) = dWlim
      enddo
      enddo
      enddo
        enddo
        return
        end
      subroutine DIVUEDGE(
     & divu
     & ,idivulo0,idivulo1,idivulo2
     & ,idivuhi0,idivuhi1,idivuhi2
     & ,uNorm
     & ,iuNormlo0,iuNormlo1,iuNormlo2
     & ,iuNormhi0,iuNormhi1,iuNormhi2
     & ,duTan
     & ,iduTanlo0,iduTanlo1,iduTanlo2
     & ,iduTanhi0,iduTanhi1,iduTanhi2
     & ,nduTancomp
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer idivulo0,idivulo1,idivulo2
      integer idivuhi0,idivuhi1,idivuhi2
      REAL*8 divu(
     & idivulo0:idivuhi0,
     & idivulo1:idivuhi1,
     & idivulo2:idivuhi2)
      integer iuNormlo0,iuNormlo1,iuNormlo2
      integer iuNormhi0,iuNormhi1,iuNormhi2
      REAL*8 uNorm(
     & iuNormlo0:iuNormhi0,
     & iuNormlo1:iuNormhi1,
     & iuNormlo2:iuNormhi2)
      integer nduTancomp
      integer iduTanlo0,iduTanlo1,iduTanlo2
      integer iduTanhi0,iduTanhi1,iduTanhi2
      REAL*8 duTan(
     & iduTanlo0:iduTanhi0,
     & iduTanlo1:iduTanhi1,
     & iduTanlo2:iduTanhi2,
     & 0:nduTancomp-1)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i,j,k,ioff,joff,koff
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          divu(i,j,k) = uNorm(i ,j ,k )
     & - uNorm(i-ioff,j-joff,k-koff)
          divu(i,j,k) = divu(i,j,k)
     & + (0.500d0)*(duTan(i ,j ,k ,0)
     & +duTan(i-ioff,j-joff,k-koff,0))
          divu(i,j,k) = divu(i,j,k)
     & + (0.500d0)*(duTan(i ,j ,k ,1)
     & +duTan(i-ioff,j-joff,k-koff,1))
      enddo
      enddo
      enddo
        if (hasLo .eq. 1) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
             divu(i,j,k) = divu(i+ioff,j+joff,k+koff)
      enddo
      enddo
      enddo
        endif
        if (hasHi .eq. 1) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
             divu(i,j,k) = divu(i-ioff,j-joff,k-koff)
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine ARTVISC(
     & F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,divu
     & ,idivulo0,idivulo1,idivulo2
     & ,idivuhi0,idivuhi1,idivuhi2
     & ,coeff
     & ,idir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer idivulo0,idivulo1,idivulo2
      integer idivuhi0,idivuhi1,idivuhi2
      REAL*8 divu(
     & idivulo0:idivuhi0,
     & idivulo1:idivuhi1,
     & idivulo2:idivuhi2)
      REAL*8 coeff
      integer idir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i , j , k
        integer ioff, joff, koff
        integer iv
        REAL*8 fc,dv,s1,s2



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
        do iv = 0,nFcomp - 1
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            fc = F (i ,j ,k ,iv)
            dv = divu(i ,j ,k )
            s1 = U (i ,j ,k ,iv)
            s2 = U (i-ioff,j-joff,k-koff,iv)
            F(i,j,k,iv) = fc + coeff*min(dv,(0.0d0))*(s1-s2)
      enddo
      enddo
      enddo
        enddo
        return
        end
