

















































      



      



      













      


























































































      subroutine SETSINE(
     *           augamma
     *           ,auambientDensity
     *           ,audeltaDensity
     *           ,aupressure
     *           ,aucenter
     *           ,auvelocity
     *           ,auartvisc
     *           )

      implicit none
      REAL*8 augamma
      REAL*8 auambientDensity
      REAL*8 audeltaDensity
      integer aupressure
      REAL*8 aucenter(0:2)
      REAL*8 auvelocity(0:2)
      REAL*8 auartvisc















        REAL*8 ambientdensity,deltadensity
        REAL*8 centerx,centery,centerz
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        integer pressure
        common /sinecm/
     *                  ambientdensity,deltadensity,
     *                  centerx,centery,centerz,
     *                  velx,vely,velz,
     *                  artvisc,
     *                  pressure



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu

        REAL*8 r0,p0,umag

        gamma = augamma

        ambientdensity = auambientDensity
        deltadensity = audeltaDensity

        pressure = aupressure

        
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)

        
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)

        artvisc = auartvisc

        r0 = ambientdensity
        p0 = (1.0d0)

        umag = sqrt(gamma*p0/r0)

        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*(0.500d0)*umag*umag

        return
        end


      subroutine SINEINIT(
     *           U
     *           ,iUlo0,iUlo1,iUlo2
     *           ,iUhi0,iUhi1,iUhi2
     *           ,nUcomp
     *           ,dx
     *           ,iboxlo0,iboxlo1,iboxlo2
     *           ,iboxhi0,iboxhi1,iboxhi2
     *           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     *           iUlo0:iUhi0,
     *           iUlo1:iUhi1,
     *           iUlo2:iUhi2,
     *           0:nUcomp-1)
      REAL*8 dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        REAL*8 ke,r0,p0,r,p
        REAL*8 pi
        integer i,j,k
        REAL*8 xcenter,ycenter,zcenter
        REAL*8 uu,vv,ww
        REAL*8 x,y,z















        REAL*8 ambientdensity,deltadensity
        REAL*8 centerx,centery,centerz
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        integer pressure
        common /sinecm/
     *                  ambientdensity,deltadensity,
     *                  centerx,centery,centerz,
     *                  velx,vely,velz,
     *                  artvisc,
     *                  pressure



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu

        
        xcenter = centerx
        ycenter = centery
        zcenter = centerz

        pi = (4.0d0)*atan((1.0d0))

        r0 = ambientdensity
        p0 = (1.0d0)

        
        uu = velx
        vv = vely
        ww = velz

        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + (0.500d0))*dx - xcenter
          y = (j + (0.500d0))*dx - ycenter
          z = (k + (0.500d0))*dx - zcenter

          r = r0 + deltadensity * 
     *                            (0.500d0) * (cos((2.0d0)*pi*x) + (1.0d
     &0))
     *                          * (0.500d0) * (cos((2.0d0)*pi*y) + (1.0d
     &0))
     *                          * (0.500d0) * (cos((2.0d0)*pi*z) + (1.0d
     &0))

          if (pressure .eq. (0.0d0)) then
            p = (r/r0)**gamma * p0
          else
            p = p0
          endif

          U(i,j,k,0) = r

          
          U(i,j,k,1) = uu*r
          U(i,j,k,2) = vv*r
          U(i,j,k,3) = ww*r

          U(i,j,k,4) = p/(gamma - (1.0d0)) + r*ke
        
      enddo
      enddo
      enddo

        return
        end
