

















































      



      



      













      



























































































      subroutine SOLIDBC(
     *           F
     *           ,iFlo0,iFlo1,iFlo2
     *           ,iFhi0,iFhi1,iFhi2
     *           ,nFcomp
     *           ,Wextrap
     *           ,iWextraplo0,iWextraplo1,iWextraplo2
     *           ,iWextraphi0,iWextraphi1,iWextraphi2
     *           ,nWextrapcomp
     *           ,lohisign
     *           ,dx
     *           ,dir
     *           ,iboxlo0,iboxlo1,iboxlo2
     *           ,iboxhi0,iboxhi1,iboxhi2
     *           )

      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     *           iFlo0:iFhi0,
     *           iFlo1:iFhi1,
     *           iFlo2:iFhi2,
     *           0:nFcomp-1)
      integer nWextrapcomp
      integer iWextraplo0,iWextraplo1,iWextraplo2
      integer iWextraphi0,iWextraphi1,iWextraphi2
      REAL*8 Wextrap(
     *           iWextraplo0:iWextraphi0,
     *           iWextraplo1:iWextraphi1,
     *           iWextraplo2:iWextraphi2,
     *           0:nWextrapcomp-1)
      integer lohisign
      REAL*8 dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        REAL*8 p,rho,unorm,speed
        integer i,j,k












        REAL*8 alpha,ms,xcorner
        REAL*8 artvisc
        common /rampcm/ alpha,ms,xcorner,
     *                  artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          p = Wextrap(i,j,k,4)
          rho = max(Wextrap(i,j,k,0),smallr)
          unorm = Wextrap(i,j,k,1 + dir)

          speed = sqrt(gamma*p/rho)

          F(i,j,k,0) = (0.0d0)

          
          F(i,j,k,1) = (0.0d0)
          F(i,j,k,2) = (0.0d0)
          F(i,j,k,3) = (0.0d0)

          F(i,j,k,1 + dir) = p + lohisign * rho * unorm * speed
          F(i,j,k,4) = (0.0d0)
        
      enddo
      enddo
      enddo

        return
        end


      subroutine SLOPEBCS(
     *           dW
     *           ,idWlo0,idWlo1,idWlo2
     *           ,idWhi0,idWhi1,idWhi2
     *           ,ndWcomp
     *           ,W
     *           ,iWlo0,iWlo1,iWlo2
     *           ,iWhi0,iWhi1,iWhi2
     *           ,nWcomp
     *           ,dx
     *           ,dir
     *           ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     *           ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     *           ,hasLo
     *           ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     *           ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     *           ,hasHi
     *           )

      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /


      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL*8 dW(
     *           idWlo0:idWhi0,
     *           idWlo1:idWhi1,
     *           idWlo2:idWhi2,
     *           0:ndWcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     *           iWlo0:iWhi0,
     *           iWlo1:iWhi1,
     *           iWlo2:iWhi2,
     *           0:nWcomp-1)
      REAL*8 dx
      integer dir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi

        integer i,j,k,ioff,joff,koff
        integer inorm,itan1,itan2,spacedim
        REAL*8 dvhi,dvlo,dvmin

        spacedim = 3

        
        ioff = CHF_ID(0,dir)
        joff = CHF_ID(1,dir)
        koff = CHF_ID(2,dir)

        
        inorm = 1 + dir
        itan1 = 1 + mod(dir + 1,spacedim)
        itan2 = 1 + mod(dir + 2,spacedim)

        if (hasLo .eq. 1) then
          
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0

            dW(i,j,k,0) = (0.0d0)
            dW(i,j,k,4) = (0.0d0)

            dvhi = W(i + ioff,j + joff,k + koff,inorm) -
     *             W(i       ,j       ,k       ,inorm)
            dvlo = W(i,j,k,inorm)*(2.0d0)

            dvmin = min((2.0d0)*abs(dvhi),abs(dvlo))*sign((1.0d0),dvlo)

            if (dvlo*dvhi .lt. (0.0d0)) dvmin = (0.0d0)

            
            dW(i,j,k,inorm) = dvmin
            dW(i,j,k,itan1) = (0.0d0)
            dW(i,j,k,itan2) = (0.0d0)
          
      enddo
      enddo
      enddo
        endif

        if (hasHi .eq. 1) then
          
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0

            dW(i,j,k,0) = (0.0d0)
            dW(i,j,k,4) = (0.0d0)

            dvhi = W(i       ,j       ,k       ,inorm) -
     *             W(i - ioff,j - joff,k - koff,inorm)
            dvlo = W(i,j,k,inorm)*(2.0d0)

            dvmin = min((2.0d0)*abs(dvhi),abs(dvlo))*sign((1.0d0),dvlo)

            if (dvlo*dvhi .lt. (0.0d0)) dvmin = (0.0d0)

            
            dW(i,j,k,inorm) = dvmin
            dW(i,j,k,itan1) = (0.0d0)
            dW(i,j,k,itan2) = (0.0d0)
          
      enddo
      enddo
      enddo
        endif

        return
        end
