#ifndef _EXPLOSIONF_F_H_
#define _EXPLOSIONF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETEXPLOSION ...
//
#define FORT_SETEXPLOSION FORTRAN_NAME( SETEXPLOSION ,setexplosion )
void 
FORT_SETEXPLOSION(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(aums)
      ,CHFp_CONST_REALVECT(aucenter)
      ,CHFp_CONST_REAL(ausize)
      ,CHFp_CONST_REALVECT(auvelocity)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure EXPLOSIONINIT ...
//
#define FORT_EXPLOSIONINIT FORTRAN_NAME( EXPLOSIONINIT ,explosioninit )
void 
FORT_EXPLOSIONINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}

#endif
