#ifndef _SINEF_F_H_
#define _SINEF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETSINE ...
//
#define FORT_SETSINE FORTRAN_NAME( SETSINE ,setsine )
void 
FORT_SETSINE(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(auambientDensity)
      ,CHFp_CONST_REAL(audeltaDensity)
      ,CHFp_CONST_INT(aupressure)
      ,CHFp_CONST_REALVECT(aucenter)
      ,CHFp_CONST_REALVECT(auvelocity)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure SINEINIT ...
//
#define FORT_SINEINIT FORTRAN_NAME( SINEINIT ,sineinit )
void 
FORT_SINEINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}

#endif
