#ifndef _SOLIDF_F_H_
#define _SOLIDF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SOLIDBC ...
//
#define FORT_SOLIDBC FORTRAN_NAME( SOLIDBC ,solidbc )
void 
FORT_SOLIDBC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wextrap)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure SLOPEBCS ...
//
#define FORT_SLOPEBCS FORTRAN_NAME( SLOPEBCS ,slopebcs )
void 
FORT_SLOPEBCS(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

}

#endif
